#ifndef _IPDF_
#define _IPDF_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPdf"		// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-document.h"

#include <poppler.h>
#include <glib/poppler-features.h>


class iPdf : public iDocument
{
	PopplerDocument 			*m_document;
  	PopplerPage 				*m_page;
	double 						m_scale;


	public:
								iPdf			( void );
								~iPdf			( void );
	virtual	int					get_n_pages		( void );
	virtual int					get_page_width  ( void );
	virtual int					get_page_height ( void );
	virtual GdkPixbuf*			get_page_pixbuf ( int n_page );
	virtual	void				end_plugin		( void );

	int							get_page_height_unscaled	( void );
	int							get_page_width_unscaled	( void );

	private:

	void						get_scale 	( void );
	void						get_scale2 	( void );


  	
  	void						load_pdf  ( void );
			

};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iDocument* create() {		
	printf("Creating iPdf...\n");
    return new iPdf;
}

extern "C" void destroy(iDocument* p) {
	printf("Destroying iDocument...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "application/pdf","document",1};		// Initial filetype

			factory_document[itself.name] = create;		    // Register the plugin
			factoryDestroy_document[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

